package im.zego.metaworlddemo.utils;

import android.util.Log;

import im.zego.metaworld.ZMWCameraCaptureComponent;
import im.zego.metaworld.ZegoMetaWorldService;
import im.zego.metaworld.ZegoMetaWorldView;
import im.zego.room.ZMWHomeRoom;

public class MetaHomeManager {
    private static final String TAG = "MetaHomeManager";

    private static MetaHomeManager singleton;

    private ZMWHomeRoom mZmwHomeRoom;

    public static MetaHomeManager getInstance() {
        if (singleton == null) {
            singleton = new MetaHomeManager();
        }
        return singleton;
    }

    public ZMWHomeRoom getHomeRoom() {
        if (mZmwHomeRoom == null) {
            mZmwHomeRoom = ZegoMetaWorldService.getInstance().getRoot().addComponent(ZMWHomeRoom.class);
        }
        return mZmwHomeRoom;
    }

    public void attachMetaWorldView(ZegoMetaWorldView var1) {
        ZMWCameraCaptureComponent var2;
        if ((var2 = (ZMWCameraCaptureComponent) ZegoMetaWorldService.getInstance().getRoot().getComponentInChildren(ZMWCameraCaptureComponent.class)) != null && var2.getUID() != -1) {
            var1.attachCamera(var2);
        } else {
            Log.e(TAG, "not found cameraCaptureComponent");
        }
    }

    public void destroyRoom() {
        if (mZmwHomeRoom != null) {
            mZmwHomeRoom.leave();
            mZmwHomeRoom = null;
        }
    }
}
