package im.zego.metaworlddemo.view.adapter;


import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;

import androidx.recyclerview.widget.RecyclerView;

import com.bumptech.glide.Glide;

import java.util.List;

import im.zego.metaworlddemo.R;
import im.zego.metaworlddemo.model.DecorData;

public class DecorAdapter extends RecyclerView.Adapter<DecorAdapter.ViewHolder> {

    private List<DecorData.AssetsBean> localDataSet;
    private OnDecorClickListener onDecorClickListener;
    private View lastSelectView;

    public static class ViewHolder extends RecyclerView.ViewHolder {
        private final ImageView ivDecor;

        public ViewHolder(View view) {
            super(view);

            ivDecor = (ImageView) view.findViewById(R.id.iv_decor);
        }

        public ImageView getIvDecor() {
            return ivDecor;
        }
    }

    public DecorAdapter(List<DecorData.AssetsBean> dataSet) {
        localDataSet = dataSet;
    }

    @Override
    public ViewHolder onCreateViewHolder(ViewGroup viewGroup, int viewType) {
        View view = LayoutInflater.from(viewGroup.getContext())
                .inflate(R.layout.item_decor_detail, viewGroup, false);
        ViewHolder viewHolder = new ViewHolder(view);
        view.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                if (lastSelectView != null) {
                    lastSelectView.setSelected(false);
                }
                int position = viewHolder.getAdapterPosition();
                ImageView ivDecor = view.findViewById(R.id.iv_decor);
                lastSelectView = ivDecor;
                ivDecor.setSelected(true);
                if (onDecorClickListener != null) {
                    onDecorClickListener.onClick(view, position, localDataSet.get(position));
                }
            }
        });
        return viewHolder;
    }

    @Override
    public void onBindViewHolder(ViewHolder viewHolder, final int position) {
        Glide.with(viewHolder.itemView).load(localDataSet.get(position)
                .getThumbnail()).into(viewHolder.getIvDecor());
    }

    @Override
    public int getItemCount() {
        return localDataSet.size();
    }

    public void setOnDecorClickListener(OnDecorClickListener onDecorClickListener) {
        this.onDecorClickListener = onDecorClickListener;
    }

    public interface OnDecorClickListener {
        void onClick(View view, int position, DecorData.AssetsBean bean);
    }
}