package im.zego.zegoexpress.constants;

/** video capture source. */
public enum ZegoVideoSourceType {
    /** Default capture logic, i.e. if there is a video external capture factory set, external capture is used, otherwise internal capture is used. */
    ZEGO_VIDEO_SOURCE_DEFAULT(0),
    /** No capture, i.e. no video data. */
    ZEGO_VIDEO_SOURCE_NONE(1),
    /** Video source from the camera. */
    ZEGO_VIDEO_SOURCE_CAMERA(2),
    /** The video source is from an external capture . When no external capture factory is set, it will be automatically corrected to VIDEO_SRC_CAMERA. */
    ZEGO_VIDEO_SOURCE_EXTERNAL_CAPTURE(3),
    /** The video source comes from the main publish channel. When publishing the main channel, this value cannot be set. */
    ZEGO_VIDEO_SOURCE_MAIN_PUBLISH_CHANNEL(4),
    /** Video source from media player. */
    ZEGO_VIDEO_SOURCE_PLAYER(5),
    /** Video source from screen capture. */
    ZEGO_VIDEO_SOURCE_SCREEN_CAPTURE(6);

    private int value;

    private ZegoVideoSourceType(int value) { this.value = value; }

    public int value() { return this.value; }

    public static ZegoVideoSourceType getZegoVideoSourceType(int value) {
        try {

            if (ZEGO_VIDEO_SOURCE_DEFAULT.value == value) {
                return ZEGO_VIDEO_SOURCE_DEFAULT;
            }

            if (ZEGO_VIDEO_SOURCE_NONE.value == value) {
                return ZEGO_VIDEO_SOURCE_NONE;
            }

            if (ZEGO_VIDEO_SOURCE_CAMERA.value == value) {
                return ZEGO_VIDEO_SOURCE_CAMERA;
            }

            if (ZEGO_VIDEO_SOURCE_EXTERNAL_CAPTURE.value == value) {
                return ZEGO_VIDEO_SOURCE_EXTERNAL_CAPTURE;
            }

            if (ZEGO_VIDEO_SOURCE_MAIN_PUBLISH_CHANNEL.value == value) {
                return ZEGO_VIDEO_SOURCE_MAIN_PUBLISH_CHANNEL;
            }

            if (ZEGO_VIDEO_SOURCE_PLAYER.value == value) {
                return ZEGO_VIDEO_SOURCE_PLAYER;
            }

            if (ZEGO_VIDEO_SOURCE_SCREEN_CAPTURE.value == value) {
                return ZEGO_VIDEO_SOURCE_SCREEN_CAPTURE;
            }

        } catch (Exception e) {
            throw new RuntimeException("The enumeration cannot be found");
        }
        return null;
    }
}